import es,usermsg,cfglib,gamethread,random,cmdlib

import psyco
psyco.full()

info = es.AddonInfo()
info["name"] = "Advanced Spawn Wave"
info["basename"] = "spawnwave"
info["version"] = "2.0.4"
info["authors"] = "MiB"
info["url"] = "http://www.warcraft-source.com"
info["description"] = "Advanced set of tools for respawning."

config = cfglib.AddonCFG(es.getAddonPath("spawnwave") + "/spawnwave_config.cfg")
config.text("*****************************")
config.text("*****Advanced Spawn Wave*****")
config.text("***********Config************")
config.text("*****************************")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("**Enable/Disable Settings**")
config.text("***************************")
ws_roundmsg = config.cvar("ws_roundmsg",1,"Enable/Disable telling every player at round start that spawn wave is enabled.")
ws_tell = config.cvar("ws_tell",1,"Enable/Disable telling the player that the player is going to respawn in a form of a count down.")
ws_respawn = config.cvar("ws_respawn",1,"Enable/Disable death respawning.")
ws_showplayers = config.cvar("ws_showplayers",0,"Enable/Disable showing the players how many players are alive on each team.")
ws_restrict = config.cvar("ws_restrict",1,"Enable/Disable the restrictions of respawning.")
ws_respawn_cmd = config.cvar("ws_respawn_cmd","<0>","Enable/Disable the respawning by command.\n// Set the value to set the commands.\n// Setting this variable to <0> disables this feature.\n// Example: ws_respawn_cmd <myspawn><respawn><!respawn>")
ws_team_respawn = config.cvar("ws_team_respawn",1,"Will a player be respawn after he/she joined a team?")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("***Restrictions Settings***")
config.text("***************************")
ws_restrict_team = config.cvar("ws_restrict_team","<0>","Set to the team number for teams you don't want getting ASW. <2 = T/3 = CT>\n// Example: ws_restrict_team <3> or ws_restrict_team <2> or ws_restrict_team <2><3>")
ws_restrict_lives = config.cvar("ws_restrict_lives",0,"How many lives to players get?\n// Set to 0 to disable.")
ws_restrict_lives_cmd = config.cvar("ws_restrict_lives_cmd","<!lives><lives><mylives><!mylives>","What text do you want players to use to see how many lives they have left?")
ws_restrict_respawn_cmd = config.cvar("ws_restrict_respawn_cmd","<1><0>","Who can use the respawn commands? // 1 = Dead / 0 = Alive \n // Disabled... will be reenabled next ASW update.")
config.text(" ")
config.text(" ")
config.text("***************************")
config.text("***Show Players Settings***")
config.text("***************************")
ws_showplayers_msg_enabled = config.cvar("ws_showplayers_msg_enabled",0,"Enable/Disable showing a msg to all players how many players there are alive on each team")
ws_showplayers_hostname_enabled = config.cvar("ws_showplayers_hostname_enabled",0,"Enable/Disable Displaying alive players in your server name.")
ws_showplayers_msg_type = config.cvar("ws_showplayers_msg_type","hudhint","What type of msg do you want it to be? <hudhint/centermsg>")
ws_showplayers_hostname = config.cvar("ws_showplayers_hostname","My Server CTs:%s|Ts:%s","Set the wanted name for your server.\n// Note: The first %s is the alive CT count and the second %s is the alive T count.")
config.text(" ")
config.text(" ")
config.text("**************************")
config.text("*****Respawn Settings*****")
config.text("**************************")
ws_tell_type = config.cvar("ws_tell_type","centermsg","What should the count down be? <hudhint/centermsg>")
ws_time_type = config.cvar("ws_time_type","set","How do you want the time to respawn be? <set/random>\n// Note: When using the random setting ws_time/ws_ct_time/ws_t_time are the minimum settings.")
ws_time_mode = config.cvar("ws_time_mode","normal","How do you want the time to respawn be? <normal/team>\n// Normal = It will use the time settings from ws_time and ws_time_max.\n// Team = It will use the time settings from ws_time_ct/ws_time_ct_max and ws_time_t/ws_time_t_max.")
ws_time = config.cvar("ws_time",2,"How long you want the until the player respawns.")
ws_time_max = config.cvar("ws_time_max",5,"The max time you want the wait to be for players.")
ws_ct_time = config.cvar("ws_ct_time",2,"How long you want until the ct player respawns.")
ws_ct_time_max = config.cvar("ws_ct_time_max",5,"The max time you want the wait to be for ct players.")
ws_t_time = config.cvar("ws_t_time",2,"How long you want until the t player respawns.")
ws_t_time_max = config.cvar("ws_t_time_max",5,"The max time you want the wait to be for t players.")
config.text(" ")
config.text(" ")
config.text("*****************************")
config.text("*****Advanced Spawn Wave*****")
config.text("********End of Config********")
config.text("*****************************")
config.write()

ws_players = {}
ws_restrict_mapfilter = []
ws_map = es.ServerVar("eventscripts_currentmap")

class WaveSpawnManager():
        def PlayerCheck(self,userid):
                userid = str(userid)
                if userid not in ws_players:
                        ws_players[userid] = {}
                        self.PlayerSetLives(userid,"var")

        def PlayerSetLives(self,userid,lives):
                userid = str(userid)
                if lives == "var": ws_players[userid]["lives"] = int(ws_restrict_lives)
                else: ws_players[userid]["lives"] = lives

        def GetDead(self,userid):
                return es.getplayerprop(userid,"CCSPlayer.baseclass.pl.deadflag")
        
        def Respawn(self,userid):
                if self.GetDead(userid) == 1:
                        es.setplayerprop(userid,"CCSPlayer.m_iPlayerState",0)
                        es.setplayerprop(userid,"CCSPlayer.baseclass.m_lifeState",512)
                es.server.queuecmd("es_xspawnplayer %s"%userid)

        def ShowLives(self,userid):
                userid = str(userid)
                es.usermsg("create","showlives","KeyHintText")
                es.usermsg("write","byte","showlives",1)
                es.usermsg("write","string","showlives","[Spawn Wave] Lives Left: %s"%wsplayers[userid]["lives"])
                es.usermsg("send","showlives",userid)
                es.usermsg("delete","showlives")

        def WaveSpawn(self,userid,time):
                if es.exists("userid",userid):
                        if ws_respawn and self.GetDead(userid) == 1 and es.getplayerteam(userid) > 1:
                                time -= 1
                                if ws_tell == 1:
                                        if ws_tell_type == "hudhint": usermsg.hudhint(userid,"[Spawn Wave] You will respawn in %s seconds."%time)
                                        else: es.centertell(userid,"[Spawn Wave] You will respawn in %s seconds."%time)
                                if time > 0: gamethread.delayedname(1,"wavespawn",self.WaveSpawn,(userid,time))
                                if time == 0: self.Respawn(userid)

        def ShowPlayers(self):
        	if ws_showplayers == 1:
        		if ws_showplayers_msg_enabled == 1:
        			for userid in es.getUseridList():
                                        msg = "[Spawn Wave] CTs:%s|Ts:%s"%(es.getlivingplayercount(3),es.getlivingplayercount(2))
        				if ws_showplayers_msg_type == "centermsg": es.centertell(userid,"%s"%msg)
        				else: usermsg.hudhint(userid,"%s"%msg)
        		if ws_showplayers_hostname_enabled == 1: es.ServerVar("hostname").set(str(ws_showplayers_hostname)%(es.getlivingplayercount(3),es.getlivingplayercount(2)))
        		gamethread.delayedname(0.5,"showplayers",self.ShowPlayers,())

        def EndRepeat(self):
                gamethread.cancelDelayed("wavespawn")
                gamethread.cancelDelayed("teamspawn")
                gamethread.cancelDelayed("showplayers")


ws = WaveSpawnManager()

def load():
	cmdlib.registerServerCommand("ws_mapfilter",MapFilter,"ws_mapfilter <add/remove> <mapname>")
	config.execute()
	es.addons.registerClientCommandFilter(player_command)
	es.set("ws_version",info.version,info.description)
	es.makepublic("ws_version")
	es.msg("#multi","\x05[Spawn Wave] #greenAdvanced Spawn Wave #lightgreenby #greenMiB #lightgreenis active on this server.")

def unload():
	cmdlib.unregisterServerCommand("ws_mapfilter")
	es.addons.unregisterClientCommandFilter(player_command)
	es.msg("#multi","\x05[Spawn Wave] #greenAdvanced Spawn Wave #lightgreenby #greenMiB #lightgreenis no longer active on this server.")

def round_start(ev):
	if ws_restrict == 1:
		if ws_map in ws_restrict_mapfilter: return
		if ws_restrict_lives:
			for userid in es.getUseridList():
				ws.PlayerCheck(userid)
				ws.PlayerSetLives(userid,"var")
	if ws_showplayers == 1: ws.ShowPlayers()
	if ws_roundmsg == 1: es.msg("#multi","\x05[Spawn Wave] #greenAdvanced Spawn Wave #lightgreenby #greenMiB #lightgreenis active on this server.")

def es_map_start(ev):
	ws.EndRepeat()

def round_end(ev):
        ws.EndRepeat()

def player_spawn(ev):
	ws.PlayerCheck(ev["userid"])

def player_command(userid,args):
        if args[0] == "jointeam":
                if args[1] == "2" or args[1] == "3":
                        if es.getplayerteam(userid) < 2:
                                if ws_team_respawn:
                                        gamethread.delayedname(3,"teamspawn",ws.Respawn,userid)
        return True

def player_death(ev):
	if ws_respawn == 1:
                ws.PlayerCheck(ev["userid"])
		team = int(ev["es_userteam"])
		if ws_restrict:
			if ws_map in ws_restrict_mapfilter or "<%s>"%team in str(ws_restrict_team): return
			if ws_restrict_lives:
				if ws_players[ev["userid"]]["lives"] > 1:
					ws_players[ev["userid"]]["lives"] -= 1
					ws.ShowLives(ev["userid"])
				else:
					ws.ShowLives(ev["userid"])
                                        return
                if team < 2: return
		if ws_time_type == "random":
			if ws_time_mode == "normal": ws.WaveSpawn(ev["userid"],(random.randint(int(ws_time),int(ws_time_max))))
			elif ws_time_mode == "team":
				if team == 2: ws.WaveSpawn(ev["userid"],(random.randint(int(ws_t_time),int(ws_t_time_max))))
				else: ws.WaveSpawn(ev["userid"],(random.randint(int(ws_ct_time),int(ws_ct_time_max))))
		elif ws_time_type == "set":
			if ws_time_mode == "normal": ws.WaveSpawn(ev["userid"],int(ws_time))
			elif ws_time_mode == "team":
				if team == 2: ws.WaveSpawn(ev["userid"],int(ws_t_time))
				else: ws.WaveSpawn(ev["userid"],int(ws_ct_time))

def player_say(ev):
	team = es.getplayerteam(ev["userid"])
	if ws_restrict == 1:
		if ws_map in ws_restrict_mapfilter: return
	if team < 2: return
	if ws.GetDead(ev["userid"]) == 0:
		text = "<%s>"%ev["text"]
		if text in str(ws_restrict_lives_cmd): ws.ShowLives(ev["userid"])
		if str(ws_respawn_cmd) != "<0>" and text in str(ws_respawn_cmd):
			if ws_restrict:
                                if ws_map in ws_restrict_mapfilter or "<%s>"%team in str(ws_restrict_team): return
				if ws_restrict_lives:
					if wsplayers[ev["userid"]]["lives"] > 0:
						ws_players[ev["userid"]]["lives"] -= 1
						ws.ShowLives(ev["userid"])
					else:
						ws.ShowLives(ev["userid"])
						return
                        ws.Respawn(ev["userid"])

def MapFilter(args):
	if len(args) == 2:
		if args[0] == "remove" or args[0] == "add":
			if args[0] == "add":
				if args[1] not in ws_restrict_mapfilter:
					ws_restrict_mapfilter.append(args[1])
					es.dbgmsg(0,"|ws_mapfilter| Success, the map was added to the map filter. ws_mapfilter <add/remove> <mapname>")
				else:
					es.dbgmsg(0,"|ws_mapfilter| Error, the map was already in the filter. ws_mapfilter <add/remove> <mapname>")
			if args[0] == "remove":
				if args[1] in ws_restrict_mapfilter:
					ws_restrict_mapfilter.remove(args[1])
					es.dbgmsg(0,"|ws_mapfilter| Success, the map was removed from the map filter. ws_mapfilter <add/remove> <mapname>")
				else:
					es.dbgmsg(0,"|ws_mapfilter| Error, the map wasn't in the filter. ws_mapfilter <add/remove> <mapname>")
		else:
			es.dbgmsg(0,"|ws_mapfilter| Error, you inputted the wrong arguments for the first argument. ws_mapfilter <add/remove> <mapname>")
	else:
		es.dbgmsg(0,"|ws_mapfilter| Error, you did not input the correct amount of arguments. ws_mapfilter <add/remove> <mapname>")
